注册 登录  
 加关注
   显示下一条  |  关闭
温馨提示!由于新浪微博认证机制调整,您的新浪微博帐号绑定已过期,请重新绑定!立即重新绑定新浪微博》  |  关闭

信息 灵感 创新

I? =Information,Inspiration,Innovation

 
 
 

日志

 
 
关于我

we are 5. Mathematics, Computation, Programming, Engineering, and Making fun of life.

网易考拉推荐

用Polyline画图  

2010-12-02 16:03:42|  分类: ObjectARX |  标签: |举报 |字号 订阅

  下载LOFTER 我的照片书  |

[CommandMethod("CLOVER")]
public void Clover()
{
    Document doc = Application.DocumentManager.MdiActiveDocument;
    Database db = doc.Database;
    Editor ed = doc.Editor;
    Transaction trans = db.TransactionManager.StartTransaction();
    BlockTable bt = trans.GetObject(db.BlockTableId, OpenMode.ForRead) as BlockTable;
    BlockTableRecord btr = trans.GetObject(bt[BlockTableRecord.ModelSpace], OpenMode.ForWrite) as BlockTableRecord;
    PromptPointOptions ppo = new PromptPointOptions("\n请输入绘图中心:");
    PromptPointResult ppr;
    Point3d temp = new Point3d();
    Point2d p1;
    //获取点
    do
    {
        ppr = ed.GetPoint(ppo);
        temp = ppr.Value;
        p1 = new Point2d(temp.X, temp.Y);
    } while (ppr.Status != PromptStatus.OK);
   
    double R = 0;
    //获取半径
    do
    {
        PromptDoubleOptions pdo = new PromptDoubleOptions("\n请指定半径:");
        PromptDoubleResult pdr = ed.GetDouble(pdo);
        if (pdr.Status == PromptStatus.OK)
            R = pdr.Value;
    } while (R<0);

    Polyline poly = new Polyline();
    double Pi=Math.PI;
    double b = Math.Tan(Pi / 6);
    poly.AddVertexAt(0, new Point2d(p1.X, p1.Y + R), b, 0, 0);
    poly.AddVertexAt(1, new Point2d(p1.X+R*Math.Cos(11*Pi/6), p1.Y + R*Math.Sin(11*Pi/6)), b, 0, 0);
    poly.AddVertexAt(2, new Point2d(p1.X+R*Math.Cos(7*Pi/6), p1.Y + R*Math.Sin(7*Pi/6)), b, 0, 0);
    poly.AddVertexAt(3, new Point2d(p1.X, p1.Y + R), b, 0, 0);
    btr.AppendEntity(poly);
    trans.AddNewlyCreatedDBObject(poly, true);
    trans.Commit();
    trans.Dispose();
}

加载运行效果如下:

用Polyline画图 - 379910987 - 年轻人,要努力!!!

  评论这张
 
阅读(1422)| 评论(0)
推荐 转载

历史上的今天

评论

<#--最新日志,群博日志--> <#--推荐日志--> <#--引用记录--> <#--博主推荐--> <#--随机阅读--> <#--首页推荐--> <#--历史上的今天--> <#--被推荐日志--> <#--上一篇,下一篇--> <#-- 热度 --> <#-- 网易新闻广告 --> <#--右边模块结构--> <#--评论模块结构--> <#--引用模块结构--> <#--博主发起的投票-->
 
 
 
 
 
 
 
 
 
 
 
 
 
 

页脚

网易公司版权所有 ©1997-2016